#!/usr/bin/env python

import locale

class ACEEncodingDecodeException(Exception): #{{{1
    def __init__(self, encoding):
        self.msgsource = 'Error decoding string'
        self.errmsg    = 'Encoding tried was %s' % encoding

    def __str__(self):
        return "%s: %s" % (self.msgsource, self.errmsg)

class ACEEncoding(): #{{{1
    def __init__(self): #{{{2
        sys_locale   = locale.getdefaultlocale()
        sys_encoding = locale.normalize(sys_locale[0]).split('.')[1]

        if sys_locale[0][0:2] == 'en':
            sys_encoding = 'CP1252'

        self._encoding = sys_encoding
        self._sysEncoding = sys_encoding

    def fromQString(self, strng): #{{{2
        return unicode(strng.toUtf8(), 'utf-8').encode(self._encoding)

    def toQString(self, strng): #{{{2
        try:
            qStrng = unicode(strng, self._encoding)
        except Exception, e:
            raise ACEEncodingDecodeException(self._encoding)

        return qStrng

    def getEncoding(self): #{{{2
        enc = self._encoding

        if enc == self._sysEncoding:
            return 'Default'
        else:
            return enc

    def setEncoding(self, enc): #{{{2
        if enc == 'Default':
            self._encoding = self._sysEncoding
        else:
            self._encoding = self.fromQString(enc)
